
#ifndef __FSOFRAMEWORK_H__
#define __FSOFRAMEWORK_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <dbus/dbus-glib.h>
#include <sys/types.h>

G_BEGIN_DECLS


#define FSO_FRAMEWORK_TYPE_ABSTRACT_WORKER_QUEUE (fso_framework_abstract_worker_queue_get_type ())
#define FSO_FRAMEWORK_ABSTRACT_WORKER_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_WORKER_QUEUE, FsoFrameworkAbstractWorkerQueue))
#define FSO_FRAMEWORK_IS_ABSTRACT_WORKER_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_WORKER_QUEUE))
#define FSO_FRAMEWORK_ABSTRACT_WORKER_QUEUE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_WORKER_QUEUE, FsoFrameworkAbstractWorkerQueueIface))

typedef struct _FsoFrameworkAbstractWorkerQueue FsoFrameworkAbstractWorkerQueue;
typedef struct _FsoFrameworkAbstractWorkerQueueIface FsoFrameworkAbstractWorkerQueueIface;

#define FSO_FRAMEWORK_TYPE_ASYNC_WORKER_QUEUE (fso_framework_async_worker_queue_get_type ())
#define FSO_FRAMEWORK_ASYNC_WORKER_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_ASYNC_WORKER_QUEUE, FsoFrameworkAsyncWorkerQueue))
#define FSO_FRAMEWORK_ASYNC_WORKER_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_ASYNC_WORKER_QUEUE, FsoFrameworkAsyncWorkerQueueClass))
#define FSO_FRAMEWORK_IS_ASYNC_WORKER_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_ASYNC_WORKER_QUEUE))
#define FSO_FRAMEWORK_IS_ASYNC_WORKER_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_ASYNC_WORKER_QUEUE))
#define FSO_FRAMEWORK_ASYNC_WORKER_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_ASYNC_WORKER_QUEUE, FsoFrameworkAsyncWorkerQueueClass))

typedef struct _FsoFrameworkAsyncWorkerQueue FsoFrameworkAsyncWorkerQueue;
typedef struct _FsoFrameworkAsyncWorkerQueueClass FsoFrameworkAsyncWorkerQueueClass;
typedef struct _FsoFrameworkAsyncWorkerQueuePrivate FsoFrameworkAsyncWorkerQueuePrivate;

#define FSO_FRAMEWORK_TYPE_SMART_KEY_FILE (fso_framework_smart_key_file_get_type ())
#define FSO_FRAMEWORK_SMART_KEY_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE, FsoFrameworkSmartKeyFile))
#define FSO_FRAMEWORK_SMART_KEY_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE, FsoFrameworkSmartKeyFileClass))
#define FSO_FRAMEWORK_IS_SMART_KEY_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE))
#define FSO_FRAMEWORK_IS_SMART_KEY_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE))
#define FSO_FRAMEWORK_SMART_KEY_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE, FsoFrameworkSmartKeyFileClass))

typedef struct _FsoFrameworkSmartKeyFile FsoFrameworkSmartKeyFile;
typedef struct _FsoFrameworkSmartKeyFileClass FsoFrameworkSmartKeyFileClass;

#define FSO_FRAMEWORK_TYPE_LOGGER (fso_framework_logger_get_type ())
#define FSO_FRAMEWORK_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_LOGGER, FsoFrameworkLogger))
#define FSO_FRAMEWORK_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_LOGGER))
#define FSO_FRAMEWORK_LOGGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FSO_FRAMEWORK_TYPE_LOGGER, FsoFrameworkLoggerIface))

typedef struct _FsoFrameworkLogger FsoFrameworkLogger;
typedef struct _FsoFrameworkLoggerIface FsoFrameworkLoggerIface;

#define FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER (fso_framework_abstract_logger_get_type ())
#define FSO_FRAMEWORK_ABSTRACT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER, FsoFrameworkAbstractLogger))
#define FSO_FRAMEWORK_ABSTRACT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER, FsoFrameworkAbstractLoggerClass))
#define FSO_FRAMEWORK_IS_ABSTRACT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER))
#define FSO_FRAMEWORK_IS_ABSTRACT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER))
#define FSO_FRAMEWORK_ABSTRACT_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_LOGGER, FsoFrameworkAbstractLoggerClass))

typedef struct _FsoFrameworkAbstractLogger FsoFrameworkAbstractLogger;
typedef struct _FsoFrameworkAbstractLoggerClass FsoFrameworkAbstractLoggerClass;
typedef struct _FsoFrameworkAbstractLoggerPrivate FsoFrameworkAbstractLoggerPrivate;

#define FSO_FRAMEWORK_TYPE_NULL_LOGGER (fso_framework_null_logger_get_type ())
#define FSO_FRAMEWORK_NULL_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_NULL_LOGGER, FsoFrameworkNullLogger))
#define FSO_FRAMEWORK_NULL_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_NULL_LOGGER, FsoFrameworkNullLoggerClass))
#define FSO_FRAMEWORK_IS_NULL_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_NULL_LOGGER))
#define FSO_FRAMEWORK_IS_NULL_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_NULL_LOGGER))
#define FSO_FRAMEWORK_NULL_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_NULL_LOGGER, FsoFrameworkNullLoggerClass))

typedef struct _FsoFrameworkNullLogger FsoFrameworkNullLogger;
typedef struct _FsoFrameworkNullLoggerClass FsoFrameworkNullLoggerClass;
typedef struct _FsoFrameworkNullLoggerPrivate FsoFrameworkNullLoggerPrivate;

#define FSO_FRAMEWORK_TYPE_FILE_LOGGER (fso_framework_file_logger_get_type ())
#define FSO_FRAMEWORK_FILE_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_FILE_LOGGER, FsoFrameworkFileLogger))
#define FSO_FRAMEWORK_FILE_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_FILE_LOGGER, FsoFrameworkFileLoggerClass))
#define FSO_FRAMEWORK_IS_FILE_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_FILE_LOGGER))
#define FSO_FRAMEWORK_IS_FILE_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_FILE_LOGGER))
#define FSO_FRAMEWORK_FILE_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_FILE_LOGGER, FsoFrameworkFileLoggerClass))

typedef struct _FsoFrameworkFileLogger FsoFrameworkFileLogger;
typedef struct _FsoFrameworkFileLoggerClass FsoFrameworkFileLoggerClass;
typedef struct _FsoFrameworkFileLoggerPrivate FsoFrameworkFileLoggerPrivate;

#define FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER (fso_framework_syslog_logger_get_type ())
#define FSO_FRAMEWORK_SYSLOG_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER, FsoFrameworkSyslogLogger))
#define FSO_FRAMEWORK_SYSLOG_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER, FsoFrameworkSyslogLoggerClass))
#define FSO_FRAMEWORK_IS_SYSLOG_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER))
#define FSO_FRAMEWORK_IS_SYSLOG_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER))
#define FSO_FRAMEWORK_SYSLOG_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_SYSLOG_LOGGER, FsoFrameworkSyslogLoggerClass))

typedef struct _FsoFrameworkSyslogLogger FsoFrameworkSyslogLogger;
typedef struct _FsoFrameworkSyslogLoggerClass FsoFrameworkSyslogLoggerClass;
typedef struct _FsoFrameworkSyslogLoggerPrivate FsoFrameworkSyslogLoggerPrivate;

#define FSO_FRAMEWORK_TYPE_BASE_KOBJECT_NOTIFIER (fso_framework_base_kobject_notifier_get_type ())
#define FSO_FRAMEWORK_BASE_KOBJECT_NOTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_BASE_KOBJECT_NOTIFIER, FsoFrameworkBaseKObjectNotifier))
#define FSO_FRAMEWORK_BASE_KOBJECT_NOTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_BASE_KOBJECT_NOTIFIER, FsoFrameworkBaseKObjectNotifierClass))
#define FSO_FRAMEWORK_IS_BASE_KOBJECT_NOTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_BASE_KOBJECT_NOTIFIER))
#define FSO_FRAMEWORK_IS_BASE_KOBJECT_NOTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_BASE_KOBJECT_NOTIFIER))
#define FSO_FRAMEWORK_BASE_KOBJECT_NOTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_BASE_KOBJECT_NOTIFIER, FsoFrameworkBaseKObjectNotifierClass))

typedef struct _FsoFrameworkBaseKObjectNotifier FsoFrameworkBaseKObjectNotifier;
typedef struct _FsoFrameworkBaseKObjectNotifierClass FsoFrameworkBaseKObjectNotifierClass;
typedef struct _FsoFrameworkBaseKObjectNotifierPrivate FsoFrameworkBaseKObjectNotifierPrivate;

#define FSO_FRAMEWORK_TYPE_ABSTRACT_OBJECT (fso_framework_abstract_object_get_type ())
#define FSO_FRAMEWORK_ABSTRACT_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_OBJECT, FsoFrameworkAbstractObject))
#define FSO_FRAMEWORK_ABSTRACT_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_ABSTRACT_OBJECT, FsoFrameworkAbstractObjectClass))
#define FSO_FRAMEWORK_IS_ABSTRACT_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_OBJECT))
#define FSO_FRAMEWORK_IS_ABSTRACT_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_ABSTRACT_OBJECT))
#define FSO_FRAMEWORK_ABSTRACT_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_OBJECT, FsoFrameworkAbstractObjectClass))

typedef struct _FsoFrameworkAbstractObject FsoFrameworkAbstractObject;
typedef struct _FsoFrameworkAbstractObjectClass FsoFrameworkAbstractObjectClass;
typedef struct _FsoFrameworkAbstractObjectPrivate FsoFrameworkAbstractObjectPrivate;

#define FSO_FRAMEWORK_TYPE_SUBSYSTEM (fso_framework_subsystem_get_type ())
#define FSO_FRAMEWORK_SUBSYSTEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_SUBSYSTEM, FsoFrameworkSubsystem))
#define FSO_FRAMEWORK_IS_SUBSYSTEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_SUBSYSTEM))
#define FSO_FRAMEWORK_SUBSYSTEM_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FSO_FRAMEWORK_TYPE_SUBSYSTEM, FsoFrameworkSubsystemIface))

typedef struct _FsoFrameworkSubsystem FsoFrameworkSubsystem;
typedef struct _FsoFrameworkSubsystemIface FsoFrameworkSubsystemIface;

#define FSO_FRAMEWORK_TYPE_PLUGIN_INFO (fso_framework_plugin_info_get_type ())
typedef struct _FsoFrameworkPluginInfo FsoFrameworkPluginInfo;

#define FSO_FRAMEWORK_TYPE_PLUGIN (fso_framework_plugin_get_type ())
#define FSO_FRAMEWORK_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_PLUGIN, FsoFrameworkPlugin))
#define FSO_FRAMEWORK_IS_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_PLUGIN))
#define FSO_FRAMEWORK_PLUGIN_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FSO_FRAMEWORK_TYPE_PLUGIN, FsoFrameworkPluginIface))

typedef struct _FsoFrameworkPlugin FsoFrameworkPlugin;
typedef struct _FsoFrameworkPluginIface FsoFrameworkPluginIface;

#define FSO_FRAMEWORK_TYPE_BASE_PLUGIN (fso_framework_base_plugin_get_type ())
#define FSO_FRAMEWORK_BASE_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_BASE_PLUGIN, FsoFrameworkBasePlugin))
#define FSO_FRAMEWORK_BASE_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_BASE_PLUGIN, FsoFrameworkBasePluginClass))
#define FSO_FRAMEWORK_IS_BASE_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_BASE_PLUGIN))
#define FSO_FRAMEWORK_IS_BASE_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_BASE_PLUGIN))
#define FSO_FRAMEWORK_BASE_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_BASE_PLUGIN, FsoFrameworkBasePluginClass))

typedef struct _FsoFrameworkBasePlugin FsoFrameworkBasePlugin;
typedef struct _FsoFrameworkBasePluginClass FsoFrameworkBasePluginClass;
typedef struct _FsoFrameworkBasePluginPrivate FsoFrameworkBasePluginPrivate;
typedef struct _FsoFrameworkSmartKeyFilePrivate FsoFrameworkSmartKeyFilePrivate;

#define FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION (fso_framework_smart_key_file_section_get_type ())
#define FSO_FRAMEWORK_SMART_KEY_FILE_SECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION, FsoFrameworkSmartKeyFileSection))
#define FSO_FRAMEWORK_SMART_KEY_FILE_SECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION, FsoFrameworkSmartKeyFileSectionClass))
#define FSO_FRAMEWORK_IS_SMART_KEY_FILE_SECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION))
#define FSO_FRAMEWORK_IS_SMART_KEY_FILE_SECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION))
#define FSO_FRAMEWORK_SMART_KEY_FILE_SECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_SMART_KEY_FILE_SECTION, FsoFrameworkSmartKeyFileSectionClass))

typedef struct _FsoFrameworkSmartKeyFileSection FsoFrameworkSmartKeyFileSection;
typedef struct _FsoFrameworkSmartKeyFileSectionClass FsoFrameworkSmartKeyFileSectionClass;
typedef struct _FsoFrameworkSmartKeyFileSectionPrivate FsoFrameworkSmartKeyFileSectionPrivate;

#define FSO_FRAMEWORK_TYPE_ABSTRACT_SUBSYSTEM (fso_framework_abstract_subsystem_get_type ())
#define FSO_FRAMEWORK_ABSTRACT_SUBSYSTEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_SUBSYSTEM, FsoFrameworkAbstractSubsystem))
#define FSO_FRAMEWORK_ABSTRACT_SUBSYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_ABSTRACT_SUBSYSTEM, FsoFrameworkAbstractSubsystemClass))
#define FSO_FRAMEWORK_IS_ABSTRACT_SUBSYSTEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_SUBSYSTEM))
#define FSO_FRAMEWORK_IS_ABSTRACT_SUBSYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_ABSTRACT_SUBSYSTEM))
#define FSO_FRAMEWORK_ABSTRACT_SUBSYSTEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_ABSTRACT_SUBSYSTEM, FsoFrameworkAbstractSubsystemClass))

typedef struct _FsoFrameworkAbstractSubsystem FsoFrameworkAbstractSubsystem;
typedef struct _FsoFrameworkAbstractSubsystemClass FsoFrameworkAbstractSubsystemClass;
typedef struct _FsoFrameworkAbstractSubsystemPrivate FsoFrameworkAbstractSubsystemPrivate;

#define FSO_FRAMEWORK_TYPE_BASE_SUBSYSTEM (fso_framework_base_subsystem_get_type ())
#define FSO_FRAMEWORK_BASE_SUBSYSTEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_BASE_SUBSYSTEM, FsoFrameworkBaseSubsystem))
#define FSO_FRAMEWORK_BASE_SUBSYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_BASE_SUBSYSTEM, FsoFrameworkBaseSubsystemClass))
#define FSO_FRAMEWORK_IS_BASE_SUBSYSTEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_BASE_SUBSYSTEM))
#define FSO_FRAMEWORK_IS_BASE_SUBSYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_BASE_SUBSYSTEM))
#define FSO_FRAMEWORK_BASE_SUBSYSTEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_BASE_SUBSYSTEM, FsoFrameworkBaseSubsystemClass))

typedef struct _FsoFrameworkBaseSubsystem FsoFrameworkBaseSubsystem;
typedef struct _FsoFrameworkBaseSubsystemClass FsoFrameworkBaseSubsystemClass;
typedef struct _FsoFrameworkBaseSubsystemPrivate FsoFrameworkBaseSubsystemPrivate;

#define TYPE_DBUS_OBJECTS (dbus_objects_get_type ())
#define DBUS_OBJECTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DBUS_OBJECTS, DBusObjects))
#define IS_DBUS_OBJECTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DBUS_OBJECTS))
#define DBUS_OBJECTS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DBUS_OBJECTS, DBusObjectsIface))

typedef struct _DBusObjects DBusObjects;
typedef struct _DBusObjectsIface DBusObjectsIface;

#define FSO_FRAMEWORK_TYPE_DBUS_SUBSYSTEM (fso_framework_dbus_subsystem_get_type ())
#define FSO_FRAMEWORK_DBUS_SUBSYSTEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FSO_FRAMEWORK_TYPE_DBUS_SUBSYSTEM, FsoFrameworkDBusSubsystem))
#define FSO_FRAMEWORK_DBUS_SUBSYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FSO_FRAMEWORK_TYPE_DBUS_SUBSYSTEM, FsoFrameworkDBusSubsystemClass))
#define FSO_FRAMEWORK_IS_DBUS_SUBSYSTEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FSO_FRAMEWORK_TYPE_DBUS_SUBSYSTEM))
#define FSO_FRAMEWORK_IS_DBUS_SUBSYSTEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FSO_FRAMEWORK_TYPE_DBUS_SUBSYSTEM))
#define FSO_FRAMEWORK_DBUS_SUBSYSTEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FSO_FRAMEWORK_TYPE_DBUS_SUBSYSTEM, FsoFrameworkDBusSubsystemClass))

typedef struct _FsoFrameworkDBusSubsystem FsoFrameworkDBusSubsystem;
typedef struct _FsoFrameworkDBusSubsystemClass FsoFrameworkDBusSubsystemClass;
typedef struct _FsoFrameworkDBusSubsystemPrivate FsoFrameworkDBusSubsystemPrivate;
typedef struct _FsoFrameworkAsyncEventFd FsoFrameworkAsyncEventFd;

typedef void (*AbstractWorkerQueueWorkerFunc) (gconstpointer element, void* user_data);
/**
 * @class FsoFramework.AbstractWorkerQueue
 **/
struct _FsoFrameworkAbstractWorkerQueueIface {
	GTypeInterface parent_iface;
	void (*setDelegate) (FsoFrameworkAbstractWorkerQueue* self, AbstractWorkerQueueWorkerFunc worker, void* worker_target);
	void (*enqueue) (FsoFrameworkAbstractWorkerQueue* self, gconstpointer element);
	void (*trigger) (FsoFrameworkAbstractWorkerQueue* self);
};

/**
 * @class FsoFramework.AsyncWorkerQueue
 **/
struct _FsoFrameworkAsyncWorkerQueue {
	GObject parent_instance;
	FsoFrameworkAsyncWorkerQueuePrivate * priv;
	GQueue* q;
	AbstractWorkerQueueWorkerFunc worker;
	gpointer worker_target;
};

struct _FsoFrameworkAsyncWorkerQueueClass {
	GObjectClass parent_class;
};

/**
 * Delegates
 */
typedef char* (*ReprDelegate) (void* user_data);
/**
 * Logger
 */
struct _FsoFrameworkLoggerIface {
	GTypeInterface parent_iface;
	void (*setLevel) (FsoFrameworkLogger* self, GLogLevelFlags level);
	void (*setDestination) (FsoFrameworkLogger* self, const char* destination);
	void (*setReprDelegate) (FsoFrameworkLogger* self, ReprDelegate repr, void* repr_target);
	void (*debug) (FsoFrameworkLogger* self, const char* message);
	void (*info) (FsoFrameworkLogger* self, const char* message);
	void (*warning) (FsoFrameworkLogger* self, const char* message);
	void (*error) (FsoFrameworkLogger* self, const char* message);
};

/**
 * AbstractLogger
 */
struct _FsoFrameworkAbstractLogger {
	GObject parent_instance;
	FsoFrameworkAbstractLoggerPrivate * priv;
	guint level;
	char* domain;
	char* destination;
};

struct _FsoFrameworkAbstractLoggerClass {
	GObjectClass parent_class;
	void (*write) (FsoFrameworkAbstractLogger* self, const char* message);
	char* (*format) (FsoFrameworkAbstractLogger* self, const char* message, const char* level);
};

/**
 * NullLogger
 */
struct _FsoFrameworkNullLogger {
	FsoFrameworkAbstractLogger parent_instance;
	FsoFrameworkNullLoggerPrivate * priv;
};

struct _FsoFrameworkNullLoggerClass {
	FsoFrameworkAbstractLoggerClass parent_class;
};

/**
 * FileLogger
 */
struct _FsoFrameworkFileLogger {
	FsoFrameworkAbstractLogger parent_instance;
	FsoFrameworkFileLoggerPrivate * priv;
};

struct _FsoFrameworkFileLoggerClass {
	FsoFrameworkAbstractLoggerClass parent_class;
};

/**
 * SyslogLogger
 */
struct _FsoFrameworkSyslogLogger {
	FsoFrameworkAbstractLogger parent_instance;
	FsoFrameworkSyslogLoggerPrivate * priv;
};

struct _FsoFrameworkSyslogLoggerClass {
	FsoFrameworkAbstractLoggerClass parent_class;
};

typedef void (*FsoFrameworkKObjectNotifierFunc) (GHashTable* properties, void* user_data);
/**
 * @class FsoFramework.BaseKObjectNotifier
 **/
struct _FsoFrameworkBaseKObjectNotifier {
	GObject parent_instance;
	FsoFrameworkBaseKObjectNotifierPrivate * priv;
};

struct _FsoFrameworkBaseKObjectNotifierClass {
	GObjectClass parent_class;
};

/**
 * @class FsoFramework.BaseObject
 **/
struct _FsoFrameworkAbstractObject {
	GObject parent_instance;
	FsoFrameworkAbstractObjectPrivate * priv;
	FsoFrameworkSmartKeyFile* config;
	FsoFrameworkLogger* logger;
};

struct _FsoFrameworkAbstractObjectClass {
	GObjectClass parent_class;
	char* (*repr) (FsoFrameworkAbstractObject* self);
};

/**
 * Errors
 */
typedef enum  {
	FSO_FRAMEWORK_PLUGIN_ERROR_UNABLE_TO_LOAD,
	FSO_FRAMEWORK_PLUGIN_ERROR_REGISTER_NOT_FOUND,
	FSO_FRAMEWORK_PLUGIN_ERROR_FACTORY_NOT_FOUND,
	FSO_FRAMEWORK_PLUGIN_ERROR_UNABLE_TO_INITIALIZE
} FsoFrameworkPluginError;
#define FSO_FRAMEWORK_PLUGIN_ERROR fso_framework_plugin_error_quark ()
/**
 * PluginInfo
 */
struct _FsoFrameworkPluginInfo {
	char* name;
	gboolean loaded;
};

/**
 * Subsystem
 */
struct _FsoFrameworkSubsystemIface {
	GTypeInterface parent_iface;
	guint (*registerPlugins) (FsoFrameworkSubsystem* self);
	guint (*loadPlugins) (FsoFrameworkSubsystem* self);
	char* (*name) (FsoFrameworkSubsystem* self);
	GList* (*pluginsInfo) (FsoFrameworkSubsystem* self);
	gboolean (*registerServiceName) (FsoFrameworkSubsystem* self, const char* servicename);
	gboolean (*registerServiceObject) (FsoFrameworkSubsystem* self, const char* servicename, const char* objectname, GObject* obj);
};

/**
 * Delegates
 */
typedef char* (*FsoFrameworkFactoryFunc) (FsoFrameworkSubsystem* subsystem, GError** error);
typedef void (*FsoFrameworkRegisterFunc) (GTypeModule* bar);
/**
 * Plugin
 */
struct _FsoFrameworkPluginIface {
	GTypeInterface parent_iface;
	void (*loadAndInit) (FsoFrameworkPlugin* self, GError** error);
	FsoFrameworkPluginInfo (*info) (FsoFrameworkPlugin* self);
};

/**
 * BasePlugin
 */
struct _FsoFrameworkBasePlugin {
	GTypeModule parent_instance;
	FsoFrameworkBasePluginPrivate * priv;
};

struct _FsoFrameworkBasePluginClass {
	GTypeModuleClass parent_class;
};

/**
 * SmartKeyFile
 */
struct _FsoFrameworkSmartKeyFile {
	GObject parent_instance;
	FsoFrameworkSmartKeyFilePrivate * priv;
};

struct _FsoFrameworkSmartKeyFileClass {
	GObjectClass parent_class;
};

/**
 * SmartKeyFileSection
 */
struct _FsoFrameworkSmartKeyFileSection {
	GObject parent_instance;
	FsoFrameworkSmartKeyFileSectionPrivate * priv;
};

struct _FsoFrameworkSmartKeyFileSectionClass {
	GObjectClass parent_class;
};

/**
 * AbstractSubsystem
 */
struct _FsoFrameworkAbstractSubsystem {
	GObject parent_instance;
	FsoFrameworkAbstractSubsystemPrivate * priv;
	FsoFrameworkLogger* logger;
};

struct _FsoFrameworkAbstractSubsystemClass {
	GObjectClass parent_class;
	gboolean (*registerServiceName) (FsoFrameworkAbstractSubsystem* self, const char* servicename);
	gboolean (*registerServiceObject) (FsoFrameworkAbstractSubsystem* self, const char* servicename, const char* objectname, GObject* obj);
};

/**
 * BaseSubsystem
 */
struct _FsoFrameworkBaseSubsystem {
	FsoFrameworkAbstractSubsystem parent_instance;
	FsoFrameworkBaseSubsystemPrivate * priv;
};

struct _FsoFrameworkBaseSubsystemClass {
	FsoFrameworkAbstractSubsystemClass parent_class;
};

/**
 * Subsystem query interface
 */
struct _DBusObjectsIface {
	GTypeInterface parent_iface;
	void (*getNodes) (DBusObjects* self, GError** error);
};

/**
 * DBusSubsystem
 */
struct _FsoFrameworkDBusSubsystem {
	FsoFrameworkAbstractSubsystem parent_instance;
	FsoFrameworkDBusSubsystemPrivate * priv;
};

struct _FsoFrameworkDBusSubsystemClass {
	FsoFrameworkAbstractSubsystemClass parent_class;
};

struct _FsoFrameworkAsyncEventFd {
	GIOChannel* channel;
	guint watch;
};


GType fso_framework_abstract_worker_queue_get_type (void);
void fso_framework_abstract_worker_queue_setDelegate (FsoFrameworkAbstractWorkerQueue* self, AbstractWorkerQueueWorkerFunc worker, void* worker_target);
void fso_framework_abstract_worker_queue_enqueue (FsoFrameworkAbstractWorkerQueue* self, gconstpointer element);
void fso_framework_abstract_worker_queue_trigger (FsoFrameworkAbstractWorkerQueue* self);
GType fso_framework_async_worker_queue_get_type (void);
gboolean _fso_framework_async_worker_queue_onIdle (FsoFrameworkAsyncWorkerQueue* self);
FsoFrameworkAsyncWorkerQueue* fso_framework_async_worker_queue_new (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func);
FsoFrameworkAsyncWorkerQueue* fso_framework_async_worker_queue_construct (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func);
#define FSO_FRAMEWORK_DEFAULT_LOG_TYPE "none"
#define FSO_FRAMEWORK_DEFAULT_LOG_LEVEL "INFO"
#define FSO_FRAMEWORK_DEFAULT_LOG_DESTINATION "/tmp/frameworkd.log"
GType fso_framework_smart_key_file_get_type (void);
FsoFrameworkSmartKeyFile* fso_framework_theMasterKeyFile (void);
GType fso_framework_logger_get_type (void);
FsoFrameworkLogger* fso_framework_createLogger (const char* domain);
char* fso_framework_getPrefixForExecutable (void);
#define FSO_FRAMEWORK_ServiceDBusPrefix "org.freesmartphone"
#define FSO_FRAMEWORK_ServicePathPrefix "/org/freesmartphone"
#define FSO_FRAMEWORK_ServiceFacePrefix "org.freesmartphone"
#define FSO_FRAMEWORK_DEVICE_ServiceDBusName FSO_FRAMEWORK_ServiceDBusPrefix ".odeviced"
#define FSO_FRAMEWORK_DEVICE_ServiceFacePrefix FSO_FRAMEWORK_ServiceFacePrefix ".Device"
#define FSO_FRAMEWORK_DEVICE_ServicePathPrefix FSO_FRAMEWORK_ServicePathPrefix "/Device"
#define FSO_FRAMEWORK_DEVICE_AudioServiceFace FSO_FRAMEWORK_DEVICE_ServiceFacePrefix ".Audio"
#define FSO_FRAMEWORK_DEVICE_AudioServicePath FSO_FRAMEWORK_DEVICE_ServicePathPrefix "/Audio"
#define FSO_FRAMEWORK_DEVICE_DisplayServiceFace FSO_FRAMEWORK_DEVICE_ServiceFacePrefix ".Display"
#define FSO_FRAMEWORK_DEVICE_DisplayServicePath FSO_FRAMEWORK_DEVICE_ServicePathPrefix "/Display"
#define FSO_FRAMEWORK_DEVICE_IdleNotifierServiceFace FSO_FRAMEWORK_DEVICE_ServiceFacePrefix ".IdleNotifier"
#define FSO_FRAMEWORK_DEVICE_IdleNotifierServicePath FSO_FRAMEWORK_DEVICE_ServicePathPrefix "/IdleNotifier"
#define FSO_FRAMEWORK_DEVICE_InfoServiceFace FSO_FRAMEWORK_DEVICE_ServiceFacePrefix ".Info"
#define FSO_FRAMEWORK_DEVICE_InfoServicePath FSO_FRAMEWORK_DEVICE_ServicePathPrefix "/Info"
#define FSO_FRAMEWORK_DEVICE_InputServiceFace FSO_FRAMEWORK_DEVICE_ServiceFacePrefix ".Input"
#define FSO_FRAMEWORK_DEVICE_InputServicePath FSO_FRAMEWORK_DEVICE_ServicePathPrefix "/Input"
#define FSO_FRAMEWORK_DEVICE_LedServiceFace FSO_FRAMEWORK_DEVICE_ServiceFacePrefix ".LED"
#define FSO_FRAMEWORK_DEVICE_LedServicePath FSO_FRAMEWORK_DEVICE_ServicePathPrefix "/LED"
#define FSO_FRAMEWORK_DEVICE_PowerControlServiceFace FSO_FRAMEWORK_DEVICE_ServiceFacePrefix ".PowerControl"
#define FSO_FRAMEWORK_DEVICE_PowerControlServicePath FSO_FRAMEWORK_DEVICE_ServicePathPrefix "/PowerControl"
#define FSO_FRAMEWORK_DEVICE_PowerSupplyServiceFace FSO_FRAMEWORK_DEVICE_ServiceFacePrefix ".PowerSupply"
#define FSO_FRAMEWORK_DEVICE_PowerSupplyServicePath FSO_FRAMEWORK_DEVICE_ServicePathPrefix "/PowerSupply"
#define FSO_FRAMEWORK_DEVICE_RtcServiceFace FSO_FRAMEWORK_DEVICE_ServiceFacePrefix ".RTC"
#define FSO_FRAMEWORK_DEVICE_RtcServicePath FSO_FRAMEWORK_DEVICE_ServicePathPrefix "/RTC"
#define FSO_FRAMEWORK_NETWORK_ServiceDBusName FSO_FRAMEWORK_ServiceDBusPrefix ".onetworkd"
#define FSO_FRAMEWORK_NETWORK_ServiceFacePrefix FSO_FRAMEWORK_ServiceFacePrefix ".Network"
#define FSO_FRAMEWORK_NETWORK_ServicePathPrefix FSO_FRAMEWORK_ServicePathPrefix "/Network"
#define FSO_FRAMEWORK_USAGE_ServiceDBusName FSO_FRAMEWORK_ServiceDBusPrefix ".ousaged"
#define FSO_FRAMEWORK_USAGE_ServiceFacePrefix FSO_FRAMEWORK_ServiceFacePrefix ".Usage"
#define FSO_FRAMEWORK_USAGE_ServicePathPrefix FSO_FRAMEWORK_ServicePathPrefix "/Usage"
#define FSO_FRAMEWORK_TIME_ServiceDBusName FSO_FRAMEWORK_ServiceDBusPrefix ".otimed"
#define FSO_FRAMEWORK_TIME_ServiceFacePrefix FSO_FRAMEWORK_ServiceFacePrefix ".Time"
#define FSO_FRAMEWORK_TIME_ServicePathPrefix FSO_FRAMEWORK_ServicePathPrefix "/Time"
#define FSO_FRAMEWORK_TIME_AlarmServiceFace FSO_FRAMEWORK_TIME_ServiceFacePrefix ".Alarm"
#define FSO_FRAMEWORK_TIME_AlarmServicePath FSO_FRAMEWORK_TIME_ServicePathPrefix "/Alarm"
void fso_framework_logger_setLevel (FsoFrameworkLogger* self, GLogLevelFlags level);
void fso_framework_logger_setDestination (FsoFrameworkLogger* self, const char* destination);
void fso_framework_logger_setReprDelegate (FsoFrameworkLogger* self, ReprDelegate repr, void* repr_target);
void fso_framework_logger_debug (FsoFrameworkLogger* self, const char* message);
void fso_framework_logger_info (FsoFrameworkLogger* self, const char* message);
void fso_framework_logger_warning (FsoFrameworkLogger* self, const char* message);
void fso_framework_logger_error (FsoFrameworkLogger* self, const char* message);
GType fso_framework_abstract_logger_get_type (void);
void fso_framework_abstract_logger_write (FsoFrameworkAbstractLogger* self, const char* message);
char* fso_framework_abstract_logger_format (FsoFrameworkAbstractLogger* self, const char* message, const char* level);
FsoFrameworkAbstractLogger* fso_framework_abstract_logger_new (const char* domain);
FsoFrameworkAbstractLogger* fso_framework_abstract_logger_construct (GType object_type, const char* domain);
char* fso_framework_abstract_logger_levelToString (GLogLevelFlags level);
GLogLevelFlags fso_framework_abstract_logger_stringToLevel (const char* level);
GType fso_framework_null_logger_get_type (void);
FsoFrameworkNullLogger* fso_framework_null_logger_new (const char* domain);
FsoFrameworkNullLogger* fso_framework_null_logger_construct (GType object_type, const char* domain);
GType fso_framework_file_logger_get_type (void);
FsoFrameworkFileLogger* fso_framework_file_logger_new (const char* domain);
FsoFrameworkFileLogger* fso_framework_file_logger_construct (GType object_type, const char* domain);
void fso_framework_file_logger_setFile (FsoFrameworkFileLogger* self, const char* filename, gboolean append);
GType fso_framework_syslog_logger_get_type (void);
FsoFrameworkSyslogLogger* fso_framework_syslog_logger_new (const char* domain);
FsoFrameworkSyslogLogger* fso_framework_syslog_logger_construct (GType object_type, const char* domain);
GType fso_framework_base_kobject_notifier_get_type (void);
extern FsoFrameworkBaseKObjectNotifier* fso_framework_base_kobject_notifier_instance;
FsoFrameworkBaseKObjectNotifier* fso_framework_base_kobject_notifier_new (void);
FsoFrameworkBaseKObjectNotifier* fso_framework_base_kobject_notifier_construct (GType object_type);
gboolean fso_framework_base_kobject_notifier_onActionFromSocket (FsoFrameworkBaseKObjectNotifier* self, GIOChannel* source, GIOCondition condition);
void fso_framework_base_kobject_notifier_handleMessage (FsoFrameworkBaseKObjectNotifier* self, char** parts, int parts_length1);
void _fso_framework_base_kobject_notifier_addMatch (FsoFrameworkBaseKObjectNotifier* self, const char* action, const char* subsystem, FsoFrameworkKObjectNotifierFunc callback, void* callback_target);
void fso_framework_base_kobject_notifier_addMatch (const char* action, const char* path, FsoFrameworkKObjectNotifierFunc callback, void* callback_target);
GType fso_framework_abstract_object_get_type (void);
char* fso_framework_abstract_object_repr (FsoFrameworkAbstractObject* self);
const char* fso_framework_abstract_object_get_classname (FsoFrameworkAbstractObject* self);
static void fso_framework_abstract_object_set_classname (FsoFrameworkAbstractObject* self, const char* value);
GQuark fso_framework_plugin_error_quark (void);
GType fso_framework_plugin_info_get_type (void);
FsoFrameworkPluginInfo* fso_framework_plugin_info_dup (const FsoFrameworkPluginInfo* self);
void fso_framework_plugin_info_free (FsoFrameworkPluginInfo* self);
void fso_framework_plugin_info_copy (const FsoFrameworkPluginInfo* self, FsoFrameworkPluginInfo* dest);
void fso_framework_plugin_info_destroy (FsoFrameworkPluginInfo* self);
GType fso_framework_subsystem_get_type (void);
GType fso_framework_plugin_get_type (void);
void fso_framework_plugin_loadAndInit (FsoFrameworkPlugin* self, GError** error);
FsoFrameworkPluginInfo fso_framework_plugin_info (FsoFrameworkPlugin* self);
GType fso_framework_base_plugin_get_type (void);
FsoFrameworkBasePlugin* fso_framework_base_plugin_new (const char* filename, FsoFrameworkSubsystem* subsystem);
FsoFrameworkBasePlugin* fso_framework_base_plugin_construct (GType object_type, const char* filename, FsoFrameworkSubsystem* subsystem);
gboolean fso_framework_smart_key_file_loadFromFile (FsoFrameworkSmartKeyFile* self, const char* filename);
char* fso_framework_smart_key_file_stringValue (FsoFrameworkSmartKeyFile* self, const char* section, const char* key, const char* defaultvalue);
gint fso_framework_smart_key_file_intValue (FsoFrameworkSmartKeyFile* self, const char* section, const char* key, gint defaultvalue);
gboolean fso_framework_smart_key_file_boolValue (FsoFrameworkSmartKeyFile* self, const char* section, const char* key, gboolean defaultvalue);
char** fso_framework_smart_key_file_stringListValue (FsoFrameworkSmartKeyFile* self, const char* section, const char* key, char** defaultvalue, int defaultvalue_length1, int* result_length1);
gboolean fso_framework_smart_key_file_hasSection (FsoFrameworkSmartKeyFile* self, const char* section);
GList* fso_framework_smart_key_file_sectionsWithPrefix (FsoFrameworkSmartKeyFile* self, const char* prefix);
gboolean fso_framework_smart_key_file_hasKey (FsoFrameworkSmartKeyFile* self, const char* section, const char* key);
GList* fso_framework_smart_key_file_keysWithPrefix (FsoFrameworkSmartKeyFile* self, const char* section, const char* prefix);
FsoFrameworkSmartKeyFile* fso_framework_smart_key_file_new (void);
FsoFrameworkSmartKeyFile* fso_framework_smart_key_file_construct (GType object_type);
GType fso_framework_smart_key_file_section_get_type (void);
FsoFrameworkSmartKeyFileSection* fso_framework_smart_key_file_section_openSection (FsoFrameworkSmartKeyFile* kf, const char* section);
guint fso_framework_subsystem_registerPlugins (FsoFrameworkSubsystem* self);
guint fso_framework_subsystem_loadPlugins (FsoFrameworkSubsystem* self);
char* fso_framework_subsystem_name (FsoFrameworkSubsystem* self);
GList* fso_framework_subsystem_pluginsInfo (FsoFrameworkSubsystem* self);
gboolean fso_framework_subsystem_registerServiceName (FsoFrameworkSubsystem* self, const char* servicename);
gboolean fso_framework_subsystem_registerServiceObject (FsoFrameworkSubsystem* self, const char* servicename, const char* objectname, GObject* obj);
GType fso_framework_abstract_subsystem_get_type (void);
FsoFrameworkAbstractSubsystem* fso_framework_abstract_subsystem_new (const char* name);
FsoFrameworkAbstractSubsystem* fso_framework_abstract_subsystem_construct (GType object_type, const char* name);
gboolean fso_framework_abstract_subsystem_registerServiceName (FsoFrameworkAbstractSubsystem* self, const char* servicename);
gboolean fso_framework_abstract_subsystem_registerServiceObject (FsoFrameworkAbstractSubsystem* self, const char* servicename, const char* objectname, GObject* obj);
GType fso_framework_base_subsystem_get_type (void);
FsoFrameworkBaseSubsystem* fso_framework_base_subsystem_new (const char* name);
FsoFrameworkBaseSubsystem* fso_framework_base_subsystem_construct (GType object_type, const char* name);
GType dbus_objects_get_type (void);
void dbus_objects_getNodes (DBusObjects* self, GError** error);
GType fso_framework_dbus_subsystem_get_type (void);
FsoFrameworkDBusSubsystem* fso_framework_dbus_subsystem_new (const char* name);
FsoFrameworkDBusSubsystem* fso_framework_dbus_subsystem_construct (GType object_type, const char* name);
DBusGConnection* fso_framework_dbus_subsystem_dbusConnection (FsoFrameworkDBusSubsystem* self);
gboolean fso_framework_file_handling_isPresent (const char* filename);
char* fso_framework_file_handling_read (const char* filename);
void fso_framework_file_handling_write (const char* contents, const char* filename);
uid_t fso_framework_user_group_handling_uidForUser (const char* user);
gid_t fso_framework_user_group_handling_gidForGroup (const char* group);
gboolean fso_framework_user_group_handling_switchToUserAndGroup (const char* user, const char* group);
char* fso_framework_string_handling_stringListToString (char** list, int list_length1);
char* fso_framework_network_ipv4AddressForInterface (const char* iface);
char* fso_framework_utility_programName (void);
FsoFrameworkAsyncEventFd* fso_framework_async_event_fd_new (guint initvalue, GIOFunc callback, void* callback_target);
FsoFrameworkAsyncEventFd* fso_framework_async_event_fd_new (guint initvalue, GIOFunc callback, void* callback_target);
void fso_framework_async_event_fd_write (FsoFrameworkAsyncEventFd* self, gint count);
guint fso_framework_async_event_fd_read (FsoFrameworkAsyncEventFd* self);


G_END_DECLS

#endif
